#include<stdio.h>
#include<math.h>
#include<stdlib.h>

#define g 9.82
#define pi 3.14159265
#define rho 1000

float Z1, Z2, Q1, Q2, Q3, Qs1, Qs2;
float H0, Hn, Hu;
float Qn, nsvinge, L1, L2, L3, A1, A2, A3, dt, tmax;
float As1, As2, Rh1, Rh2, Rh3, M, Tl, Tavslag;

float K(float t)
{	float K;

//	if (t>=0 && t<=Tl)
//	{	K=(1/Tl)*t;
//		if (K<0.01)
//			K=0.01;		}
	if (t>=0 && t<Tavslag)
		K=1;
	else if (t>=Tavslag && t<(Tavslag+Tl))
	{	K=1-((1/Tl)*(t-Tavslag));
		if (K<0.01)
			K=0.01;		}
	else if (t>=(Tavslag+Tl))
		K=0.01;
	return K;
}

/*Definerer diffligningene*/
float F1(float x, float y)							//y=Q, x=dt
{	M = 33;
	double k=1/(g*M*M*A1*A1*pow(Rh1,(float)4/3));
	//float k=0;
	float dQ=(H0-Z1-(k*y*fabs(y)))*((g*A1)/L1)*dt;
	return dQ;		}

float F2(float t, float y)							//y=Q, x=t
{	M=33;
	double k=1/(g*M*M*A2*A2*pow(Rh2,(float)4/3));
	//float k=0;
	if(nsvinge==0)
	{	double k=L3/(M*M*A2*A2*pow(Rh2,(float)4/3));
		Z2=Hu+(k*y*fabs(y));	}

	float dQ=(Z1-Z2-(Hn*pow(y/(K(t)*Qn),2))-(k*y*fabs(y)))*((g*A2)/L2)*dt;
	return dQ;		}

float F3(float x, float y)							//y=Q, x=dt
{	M=33;
	double k=1/(g*M*M*A3*A3*pow(Rh3,(float)4/3));
	//float k=0;
	float dQ=(Z2-Hu-(k*y*fabs(y)))*((g*A3)/L3)*dt*nsvinge;
	return dQ;		}

float F4(float x, float y)
{	float dz1=(y/As1)*dt;							//x=dt
	return dz1;		}

float F5(float x, float y)							//x=dt
{	float dz2=(y/As2)*dt*nsvinge;
	return dz2;		}
/*Slutt definisjon av diffligninger*/

/*Lser diffligningene med Euler*/
int  Euler (float dt, int N)
{
	float t=0;
	int i;
	float a=1/dt;
	int A=a;
	char no[]="n", xno[]="t", yno1[]="Q1", yno2[]="Q2", yno3[]="Q3",yno4[]="Qs1", yno5[]="Qs2", zno1[]="Z1", zno2[]="Z2", ko[]="K";

	remove("resultat1.txt");
	FILE *resultat1;
	resultat1 = fopen("resultat1.txt","a");

	if(nsvinge==1)
		fprintf(resultat1,"%-12s %-11s %-11s %-11s %-11s %-11s %-11s %-11s %-11s\n", xno, yno1, yno2, yno3, yno4, yno5, zno1, zno2, ko);				//Skriver overskrifter til fil
	else
		fprintf(resultat1,"%-12s %-11s %-11s %-11s %-11s %-11s\n", xno, yno1, yno2, yno4, zno1, ko);

	for (i=1; i<=N; i++)							//Lser ligningene og lagrer i M
	{
		Q1=Q1+F1(dt, Q1);
		Q2=Q2+F2(t, Q2);
		if(nsvinge==1)
			Q3=Q3+F3(dt, Q3);
		else
			Q3=Q2;
		Qs1=Q1-Q2;
		Qs2=(Q2-Q3)*nsvinge;
		Z1=Z1+F4(dt, Qs1);
		Z2=Z2+F5(dt, Qs2);
		t=t+dt;

	//	if(i%A==0)
			if(nsvinge==1)
				fprintf(resultat1,"%10f  %10f  %10f  %10f  %10f  %10f  %10f  %10f %10f\n", t, Q1, Q2, Q3, Qs1, Qs2, Z1, Z2, K(t));
			else
				fprintf(resultat1,"%10f  %10f  %10f  %10f  %10f  %10f\n", t, Q1, Q2, Qs1, Z1, K(t));
	}
	return 0;
}
/*Slutt p Euler-lser*/

/*Hovedfunksjon kaller Euler-lseren*/
int main(void)
{

	/*pner inputfil og leser verdier til en liste "input"
	Merk at input[0] ikke benyttes*/
	FILE *in;
	in = fopen("input.txt","r");

	float input[28];
	int i;

	for (i=1; i<=27; i++)
		fscanf(in,"%f", &input[i]);
	/*slutt p input*/

	H0=input[1], Hn=input[2], Hu=input[3], Z1=input[4], Z2=input[5], Q1=input[6], Q2=input[7], Q3=input[8], Qs1=input[9], Qs2=input[10];
	Qn=input[11], nsvinge=input[12], L1=input[13], L2=input[14], L3=input[15], A1=input[16], A2=input[17], A3=input[18];
	As1=input[19], As2=input[20], dt=input[21], tmax=input[22], Rh1=input[23], Rh2=input[24], Rh3=input[25], Tl=input[26], Tavslag=input[27];

	int result = Euler(dt, tmax/dt);

	/*Plotter resultatfilen via Gnuplot*/
	// Open a pipe to gnuplot
	FILE *gnuplotPipe = popen("c:\\gnuplot\\bin\\pgnuplot -persist","w");
																			//Sjekker om gnuplot finnes
	if (gnuplotPipe) {
	  																		// Skriver kommandoer til gnuplot
	  fprintf(gnuplotPipe, "set style data lines\n");
	  fprintf(gnuplotPipe, "cd 'C:\\MinGW32'\n");
	  //fprintf(gnuplotPipe, "set xrange [1:10]\n");
	  //fprintf(gnuplotPipe, "set yrange [1:15]\n");
	  if(nsvinge==1)
	  {
	  	fprintf(gnuplotPipe, "set term wxt 0\n set grid\n set ytics 1\n set xtics 20\n set xlabel 'Tid'\n set ylabel 'Amplitude'\n plot \"resultat1.txt\" using 1:7 title 'Z1'\n");	//Plotter resultat1.txt med kolonne 1 som x og 3 som y
	  	fprintf(gnuplotPipe, "set term wxt 1\n set ytics 0.5\n  plot \"resultat1.txt\" using 1:8 title 'Z2'\n");
	  	fprintf(gnuplotPipe, "set terminal png enhanced size 1280,1024 fontscale 1.3\n  set output 'Z1.png'\n");			//Klargjr for laging av png-fil
	  	fprintf(gnuplotPipe, "set ytics 1\n plot \"resultat1.txt\" using 1:7 title 'Z1' lw 2\n");															  							//Gir navn til png-fil og plotter p nytt til den
	  	fprintf(gnuplotPipe, "set output 'Z2.png'\n");
	  	fprintf(gnuplotPipe, "plot \"resultat1.txt\" using 1:8 title 'Z2' lw 2\n");			}

	  else
	  {
		fprintf(gnuplotPipe, "set term wxt 0\n set grid\n set xlabel 'Tid'\n set ylabel 'Amplitude'\n plot \"resultat1.txt\" using 1:5 title 'Z1'\n");
	  	fprintf(gnuplotPipe, "set terminal png enhanced size 1280,1024 fontscale 1.3\n  set output 'Z1.png'\n");
	  	fprintf(gnuplotPipe, "plot \"resultat1.txt\" using 1:5 title 'Z1' lw 2\n");
	  }
	  fflush(gnuplotPipe);
	  fprintf(stderr,"Press enter to continue...");
	  fflush(stderr);
	  getchar();
	  																		// lukker gnuplot
	  fprintf(gnuplotPipe,"exit \n");
	  pclose(gnuplotPipe);
}

	return 0;
}
/*Slutt hovedfunksjon*/
